Overview | Package | Class | Tree | Deprecated | Index | Help
| Oracle® OLAP Java API Reference 10g Release 2 (10.2) B14348-02
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.olapi.metadata.mdm
Class MdmMeasure

    java.lang.Object
      |
      +--oracle.olapi.metadata.BaseMetadataObject
            |
            +--oracle.olapi.metadata.mdm.MdmObject
                  |
                  +--oracle.olapi.metadata.mdm.MdmSource
                        |
                        +--oracle.olapi.metadata.mdm.MdmDimensionedObject
                              |
                              +--oracle.olapi.metadata.mdm.MdmMeasure

public class MdmMeasure
extends MdmDimensionedObject
implements MdmMember

An `MdmDimensionedObject` that represents a set of data to use in analytical processing. The type of an `MdmMeasure` is based on the data type of the information that the `MdmMeasure` represents. In most cases, the return value of the `getType` method of an `MdmMeasure` is the `FundamentalMetadataObject` that represents an OLAP API data type such as Integer or Boolean.

An `MdmMeasure` can be based on an Oracle OLAP measure that is mapped to a column in a fact table, or to a mathematical operation or a data transformation that is based on more than one column. Such a measure has an associated `MtmMeasureMap`. You can create a custom `MdmMeasure` that is mapped to a column or to mathematical operation or a data transformation with methods of an `MdmCustomObjectFactory` such as `createNumericMeasure`.

Another kind of custom `MdmMeasure` is one that is a custom member of an `MdmMeasureDimension`. The values of this kind of custom `MdmMeasure` are specified by the `Source` that you use to create the custom measure. You can create this kind of `Source`-based custom measure with a `createCustomMeasure` method of an `MdmCustomObjectFactory` or with convenience methods of an `MdmMeasureDimension`.

For an example program that creates a custom measure by using an `MtmMeasureMap`, see CreatingCustomMeasure.java. For an example program that creates a custom measure as a member of an `MdmMeasureDimension`, see CreateCustomMeasureDimensionMember.java. For links to all of the example programs in this documentation, see Example Oracle OLAP Java API Programs.

Because an `MdmMeasure` is a metadata object, it describes the structure and characteristics of a set of data, but it does not provide the ability to create queries on the data. To create a query on the data represented by an `MdmMeasure`, an application must get the `Source` for the `MdmMeasure`.

Method Summary
`java.lang.Object` | `acceptVisitor(MdmObjectVisitor visitor, java.lang.Object context)` Calls the `visitMdmMeasure` method of the `MdmObjectVisitor` and passes that method this `MdmMeasure` and an `Object`.
`MdmLevel` | `getLevel()` Gets the `MdmLevel` of the `MdmMeasureDimension` of which the `MdmMeasure` is a member.
`int` | `getLevelDepth()` Because an `MdmMeasureDimension` has only one level, this method returns `0`.
`java.lang.String` | `getLocalValue()` Gets the local value of this `MdmMeasure`, which is its name.
`MdmMeasureDimension` | `getMeasureDimension()` Gets the `MdmMeasureDimension` of the root `MdmSchema`.
`MtmMeasureMap` | `getMeasureMap()` Gets the `MtmMeasureMap` for this `MdmMeasure`.
`MdmPrimaryDimension` | `getOwnerDimension()` Gets the `MdmPrimaryDimension` of which this `MdmMeasure` is a member.
`MdmLevel` | `getParentLevel()` Because an `MdmMeasure` does not have a parent in a dimension hierarchy, this method returns `null`.
`java.lang.String` | `getParentLocalValue()` Because an `MdmMeasure` does not have a parent in a dimension hierarchy, this method returns `null`.
`java.lang.String` | `getParentValue()` Because an `MdmMeasure` does not have a parent in a dimension hierarchy, this method returns `null`.
`int` | `getPrecedence()` Gets the precedence of this `MdmMeasure`.
`java.lang.String` | `getUnits()` Gets the type of units specified for this `MdmMeasure`.
`java.lang.String` | `getValue()` Gets the value of this `MdmMeasure`, which is the identifier for the `Source` for this `MdmMeasure`.
`java.lang.String` | `getValueFormat()` Gets the format specified for the values of this `MdmMeasure`.
`void` | `setPrecedence(int precedence)` Specifies a precedence to use as the default precedence for the `Assignment` objects of the `MdmMeasureModel` for the `MdmMeasure`, with the higher integer value indicating a higher precedence.
`void` | `setUnits(java.lang.String newUnits)` Specifies a type of units for the values of this `MdmMeasure`.
`void` | `setValueFormat(java.lang.String formatString)` Specifies a format for the values of this `MdmMeasure`.

Methods inherited from class oracle.olapi.metadata.mdm.MdmDimensionedObject
`getDimensions`

Methods inherited from class oracle.olapi.metadata.mdm.MdmSource
`getDataType, getModel, getSource, getSourceMap, getType, setModel`

Methods inherited from class oracle.olapi.metadata.mdm.MdmObject
`getDescription, getMetadataProvider, getName, getShortDescription, setDescription, setName, setShortDescription`

Methods inherited from class oracle.olapi.metadata.BaseMetadataObject
`getID`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### getMeasureMap

    public MtmMeasureMap getMeasureMap()
                                throws MetadataNotFoundException

  Gets the `MtmMeasureMap` for this `MdmMeasure`. The `MtmMeasureMap` maps the elements of this `MdmMeasure` to data in the relational database.
  Returns:
    The `MtmMeasureMap` for this `MdmMeasure`.

### getValue

    public java.lang.String getValue()

  Gets the value of this `MdmMeasure`, which is the identifier for the `Source` for this `MdmMeasure`.
  Specified by:
    getValue in interface MdmMember
  Returns:
    A `String` that is the identifier for the `Source` for this `MdmMeasure`.

### getLocalValue

    public java.lang.String getLocalValue()

  Gets the local value of this `MdmMeasure`, which is its name.
  Specified by:
    getLocalValue in interface MdmMember
  Returns:
    A `String` that contains the local value of this `MdmMeasure`.

### getOwnerDimension

    public MdmPrimaryDimension getOwnerDimension()

  Gets the `MdmPrimaryDimension` of which this `MdmMeasure` is a member. An `MdmMeasure` can be a member of an `MdmMeasureDimension`.
  Specified by:
    getOwnerDimension in interface MdmMember
  Returns:
    The `MdmPrimaryDimension` of which this `MdmMeasure` is a member.

### getMeasureDimension

    public MdmMeasureDimension getMeasureDimension()

  Gets the `MdmMeasureDimension` of the root `MdmSchema`. All `MdmMeasure` objects provided by the `MdmMetadataProvider` are members of that `MdmMeasureDimension`.
  Returns:
    The `MdmMeasureDimension` of the root `MdmSchema`

### getLevel

    public MdmLevel getLevel()

  Gets the `MdmLevel` of the `MdmMeasureDimension` of which the `MdmMeasure` is a member.
  Specified by:
    getLevel in interface MdmMember
  Returns:
    The `MdmLevel` of the `MdmMeasureDimension`.

### getLevelDepth

    public int getLevelDepth()

  Because an `MdmMeasureDimension` has only one level, this method returns `0`.
  Specified by:
    getLevelDepth in interface MdmMember
  Returns:
    An integer that indicates the level of this `MdmMeasure` in the `MdmMeasureDimension`.

### getParentValue

    public java.lang.String getParentValue()

  Because an `MdmMeasure` does not have a parent in a dimension hierarchy, this method returns `null`.
  Specified by:
    getParentValue in interface MdmMember
  Returns:
    `null`.

### getParentLocalValue

    public java.lang.String getParentLocalValue()

  Because an `MdmMeasure` does not have a parent in a dimension hierarchy, this method returns `null`.
  Specified by:
    getParentLocalValue in interface MdmMember
  Returns:
    `null`.

### getParentLevel

    public MdmLevel getParentLevel()

  Because an `MdmMeasure` does not have a parent in a dimension hierarchy, this method returns `null`.
  Specified by:
    getParentLevel in interface MdmMember
  Returns:
    `null`.

### getPrecedence

    public int getPrecedence()

  Gets the precedence of this `MdmMeasure`.
  Specified by:
    getPrecedence in interface MdmMember
  Returns:
    An integer that specifies the precedence of this `MdmMeasure`.

### getValueFormat

    public java.lang.String getValueFormat()

  Gets the format specified for the values of this `MdmMeasure`.
  Returns:
    A `String` that specifes an Oracle `COLUMN FORMAT` for the values of this `MdmMeasure`.

### setValueFormat

    public void setValueFormat(java.lang.String formatString)

  Specifies a format for the values of this `MdmMeasure`.
  Parameters:
    `formatString` - A `String` that specifes an Oracle `COLUMN FORMAT` to use for the values of this `MdmMeasure`.

### getUnits

    public java.lang.String getUnits()

  Gets the type of units specified for this `MdmMeasure`.
  Returns:
    A `String` that indicates the type of units for the values of this `MdmMeasure`.
  See Also:
    `setUnits(java.lang.String)`

### setUnits

    public void setUnits(java.lang.String newUnits)

  Specifies a type of units for the values of this `MdmMeasure`. For example, the following code specifies `kilograms` as the type of units for the values of the `MdmMeasure` `mdmWeight`.

       mdmWeight.setUnits("kilograms");

  Parameters:
    `newUnits` - A `String` that indicates the type of units for the values of this `MdmMeasure`.

### setPrecedence

    public void setPrecedence(int precedence)

  Specifies a precedence to use as the default precedence for the `Assignment` objects of the `MdmMeasureModel` for the `MdmMeasure`, with the higher integer value indicating a higher precedence. Oracle OLAP uses the precedence value in determining the order in which it evaluates the `Assignment` objects in calculations that involve more than one measure.
  Parameters:
    `precedence` - An integer that specifies the precedence for this `MdmMeasure`.

### acceptVisitor

    public java.lang.Object acceptVisitor(MdmObjectVisitor visitor,
                                          java.lang.Object context)

  Calls the `visitMdmMeasure` method of the `MdmObjectVisitor` and passes that method this `MdmMeasure` and an `Object`.
  Overrides:
    acceptVisitor in class MdmObject
  Parameters:
    `visitor` - An `MdmObjectVisitor`.
    `context` - An `Object`.
  Returns:
    The `Object` returned by the `visitMdmMeasure` method.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Oracle® OLAP Java API Reference 10g Release 2 (10.2) B14348-02
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002, 2005, Oracle. All rights reserved.